/*HelloCV2.1GL.c*/
#pragma warning(disable : 4996) // ("veraltet" nicht mehr melden!)

#define OCV_OGL
#ifdef  OCV_OGL
//#define MORE_DIP

#include <conio.h>  //wg. _getch()
#include <stdio.h>  //wg. printf()
#include <stdlib.h> //wg. exit()
#include <GL/glut.h>//wg. Konflikte: stdlib.h vor glut.h
#include <cv.h>
#include <cxcore.h>
#include <highgui.h>

#define CON_CLS   "cls"
#define ESC        27
#define PATH    "..\\..\\_Data\\"
#define PICI     "Fendi.jpg"
#define PICO     "example.bmp"//"example.jpg"

char      imgPath[80];
IplImage *ocvImg, *oglImg;

/* *********************************************************************** */
   void ocv2ogl(IplImage *ocvimg)
/* *********************************************************************** */
{/*Converting OpenCV to OpenGL image data by turning the picture bottom up 
   and changing the color scheme from GBR to RGB*/
  unsigned char *dummyImg=NULL;
  int            jhig=0, jwid=0, jcomp=0, ocvIdx=0, oglIdx=0;
  int            imgHig=ocvimg->height, imgWid=ocvimg->width, 
                 components=ocvimg->nChannels;

  if ((imgWid*components/4)*4 != imgWid*components)
  { fprintf(stderr, "\n\n Sorry, it won't work!"); 
    fprintf(stderr, "\n (To continue, press any key in this window)\n"); _getch(); }

  dummyImg = (unsigned char *) malloc(imgHig * imgWid * components);
  if (!dummyImg) { fprintf(stderr, "Out of memory!\n");  _getch();  exit(1); }
  memcpy (dummyImg, ocvimg->imageData, imgHig * imgWid * components);

  for (jhig=0; jhig<imgHig; jhig++)
  { for (jwid=0; jwid<imgWid; jwid++)
    { for (jcomp=0; jcomp<components; jcomp++)
      { ocvIdx = jhig * imgWid * components + jwid * components + jcomp; 
#ifdef  MORE_DIP
#else //MORE_DIP
        oglIdx = ocvIdx;
#endif//MORE_DIP
       (ocvimg->imageData)[ocvIdx] = dummyImg[oglIdx];
      }
    }
  }
  free (dummyImg);
  return;
}

/***************************************************************************/
  void Keyboard (unsigned char key, int x, int y)
/***************************************************************************/
{ switch (key)
  { case ESC: glutDestroyWindow(1);
              cvDestroyWindow(PICI);
              cvReleaseImage(&ocvImg);
              exit(0);
              break;
    case 'r': ocv2ogl(oglImg);
              glutPostRedisplay();
              break;
    case 's': strcpy (imgPath, PATH);  strcat (imgPath, PICO);
              cvSaveImage(imgPath, ocvImg, 0);
              break;
    case 'S': strcpy (imgPath, PATH);  strcat (imgPath, PICO);
              ocv2ogl(oglImg);
              cvSaveImage(imgPath, oglImg, 0);
              break;
  }

  system (CON_CLS);
  printf ("\n Load / store pic with OpenCV, show it with OpenGL:\n");
  printf ("\n Current pic: %s (%d x %d)\n", PICI, ocvImg->width, ocvImg->height);
  printf ("\n Keep OpenGL window active and press\n");
  printf ("\n <ESC> to quit ");
  printf ("\n  r       toggle BGR (OpenCV) / RGB (OpenGL)"); 
  printf ("\n  s       save OpenCV pic as '%s'", PICO);
  printf ("\n  S       save OpenGL pic as '%s'", PICO);
  return;

}

/***************************************************************************/
  void Display (void)
/***************************************************************************/
{ glDrawPixels(oglImg->width, oglImg->height, GL_RGB, GL_UNSIGNED_BYTE, 
               oglImg->imageData);
  glFinish(); 
  Keyboard (' ', 0, 0); //Menue ausgeben
  return;
}

/***************************************************************************/
int main (int argc, char **argv)
{ strcpy (imgPath, PATH);  strcat (imgPath, PICI);

  ocvImg = cvLoadImage(imgPath, 1);  if (!ocvImg) { _getch();  exit(0); }
  cvNamedWindow(PICI, CV_WINDOW_AUTOSIZE);
  cvShowImage(PICI,ocvImg); //erzeugt Fenster, wenn keins vorhanden

  oglImg = cvCloneImage(ocvImg);
  glutInitWindowSize(oglImg->width, oglImg->height);/*Fenstergroesse*/
  glutInit(&argc, argv);                            /*Intialisierg*/
  glutCreateWindow(PICI);                           /*Fenster-Einrichtung*/
  glutDisplayFunc (Display);                        /*Anmeldung der Callback-Funktion*/
  glutKeyboardFunc(Keyboard);                       /*Callback-Funktion fuer Tasten*/
  glutMainLoop();                                   /* we never return...Start d. Ereignis-Verarbeitung durch GLUT*/ 
  return 0;
}
#else //OCV_OGL
#include <cv.h>
#include <cxcore.h>
#include <highgui.h>
#define PICPATH "..\\..\\_Data\\Fendi.jpg"

int main (int argc, char **argv)
{ IplImage *ocvImg = cvLoadImage(PICPATH, 1);
  cvNamedWindow(PICPATH,1);
  cvShowImage(PICPATH,ocvImg);

  cvWaitKey(0);
  cvDestroyWindow(PICPATH);
  cvReleaseImage(&ocvImg);

  return 0;
}
#endif//OCV_OGL
